'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.set');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.unset');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.get');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.drop');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.has');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.isstring');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.isplainobject');

var _lodash14 = _interopRequireDefault(_lodash13);

var _lodash15 = require('lodash.reduce');

var _lodash16 = _interopRequireDefault(_lodash15);

var _lodash17 = require('lodash.defaultsdeep');

var _lodash18 = _interopRequireDefault(_lodash17);

var _lodash19 = require('lodash.clonedeep');

var _lodash20 = _interopRequireDefault(_lodash19);

var _lodash21 = require('lodash.foreach');

var _lodash22 = _interopRequireDefault(_lodash21);

var _lodash23 = require('lodash.map');

var _lodash24 = _interopRequireDefault(_lodash23);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _emptyFunc = require('./utils/emptyFunc');

var _emptyFunc2 = _interopRequireDefault(_emptyFunc);

var _arrayFrom = require('./utils/arrayFrom');

var _arrayFrom2 = _interopRequireDefault(_arrayFrom);

var _pickDeep = require('./utils/pickDeep');

var _pickDeep2 = _interopRequireDefault(_pickDeep);

var _pickOutermost = require('./utils/pickOutermost');

var _pickOutermost2 = _interopRequireDefault(_pickOutermost);

var _mergeValidatedValuePaths = require('./utils/mergeValidatedValuePaths');

var _mergeValidatedValuePaths2 = _interopRequireDefault(_mergeValidatedValuePaths);

var _valuesWithDefaultsAndExemptions = require('./utils/valuesWithDefaultsAndExemptions');

var _valuesWithDefaultsAndExemptions2 = _interopRequireDefault(_valuesWithDefaultsAndExemptions);

var _Wildcard = require('./constants/Wildcard');

var _Wildcard2 = _interopRequireDefault(_Wildcard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var Joi = void 0;

var DEFAULT_STATE = {
  errors: {},
  values: {},
  touchedValues: {},
  validatedValues: {},
  changingValues: [],

  validateAllValues: false
};

var ReactJoiValidation = function ReactJoiValidation(ValidatedComponent, _ref) {
  var joiSchema = _ref.joiSchema,
      joiOptions = _ref.joiOptions,
      validator = _ref.validator,
      only = _ref.only,
      _ref$pseudoValues = _ref.pseudoValues,
      pseudoValues = _ref$pseudoValues === undefined ? [] : _ref$pseudoValues,
      externalErrorsPath = _ref.externalErrorsPath;

  function usingSingularValidationScope() {
    return (0, _lodash12.default)(only);
  }

  function wrapObject(object) {
    if (usingSingularValidationScope()) {
      return (0, _lodash2.default)({}, only, object);
    } else {
      return object;
    }
  }

  function unwrapObject(object) {
    if (usingSingularValidationScope()) {
      return (0, _lodash6.default)(object, only);
    } else {
      return object;
    }
  }

  function pickErrors(errors, touchedValues) {

    var listOfTouchedValues = (0, _pickOutermost2.default)(touchedValues);

    var valuesToPick = [].concat(_toConsumableArray(listOfTouchedValues), _toConsumableArray((0, _arrayFrom2.default)(pseudoValues)));

    return (0, _lodash16.default)(valuesToPick, function (activeErrors, valuePath) {

      if (!valuePath.endsWith(_Wildcard2.default)) {
        var error = (0, _lodash6.default)(errors, valuePath);

        if (error) {
          (0, _lodash2.default)(activeErrors, valuePath, error);
        }
      }

      return activeErrors;
    }, {});
  }

  var ValidatorComponent = function (_Component) {
    _inherits(ValidatorComponent, _Component);

    function ValidatorComponent(props, context) {
      _classCallCheck(this, ValidatorComponent);

      var _this = _possibleConstructorReturn(this, (ValidatorComponent.__proto__ || Object.getPrototypeOf(ValidatorComponent)).call(this, props, context));

      _this.changeHandler = _this.changeHandler.bind(_this);
      _this.changesHandler = _this.changesHandler.bind(_this);
      _this.changeValue = _this.changeValue.bind(_this);
      _this.changeValues = _this.changeValues.bind(_this);

      _this.validateHandler = _this.validateHandler.bind(_this);
      _this.validate = _this.validate.bind(_this);

      _this.validateAll = _this.validateAll.bind(_this);
      _this.validateAllHandler = _this.validateAllHandler.bind(_this);

      _this.clearValidation = _this.clearValidation.bind(_this);
      _this.clearValidationState = _this.clearValidationState.bind(_this);
      _this.clearValidationAndResetValues = _this.clearValidationAndResetValues.bind(_this);
      _this.clearTouchedValues = _this.clearTouchedValues.bind(_this);

      _this.state = _extends({}, DEFAULT_STATE);
      return _this;
    }

    _createClass(ValidatorComponent, [{
      key: 'render',
      value: function render() {
        var _state = this.state,
            touchedValues = _state.touchedValues,
            values = _state.values;


        return _react2.default.createElement(ValidatedComponent, _extends({}, this.props, this._valuesWithDefaults({ values: values, touchedValues: touchedValues }), {

          errors: this._getActiveErrors(),

          changeHandler: this.changeHandler,
          changesHandler: this.changesHandler,
          changeValue: this.changeValue,
          changeValues: this.changeValues,

          validateHandler: this.validateHandler,
          validate: this.validate,

          validateAllHandler: this.validateAllHandler,
          validateAll: this.validateAll,

          clearValidationState: this.clearValidationState,
          clearValidation: this.clearValidation,
          clearValidationAndResetValues: this.clearValidationAndResetValues,
          clearValidationTouchedValues: this.clearTouchedValues
        }));
      }
    }, {
      key: 'omitDeep',
      value: function omitDeep(target, valueToOmit) {
        var _this2 = this;

        if (valueToOmit) {
          if ((0, _lodash14.default)(target)) {

            return (0, _lodash16.default)(target, function (memo, value, key) {

              if (!(0, _lodash12.default)(valueToOmit[key])) {
                memo[key] = _this2.omitDeep(value, valueToOmit[key]);
              }

              return memo;
            }, {});
          } else if (Array.isArray(target)) {

            return (0, _lodash16.default)(target, function (memo, value, index) {

              if (!(0, _lodash12.default)(valueToOmit[index])) {
                memo.push(_this2.omitDeep(value, valueToOmit[index]));
              }

              return memo;
            }, []);
          } else {
            return target;
          }
        } else {
          return target;
        }
      }
    }, {
      key: '_getActiveErrors',
      value: function _getActiveErrors() {
        var _state2 = this.state,
            errors = _state2.errors,
            validateAllValues = _state2.validateAllValues,
            touchedValues = _state2.touchedValues,
            validatedValues = _state2.validatedValues;


        var externalErrors = (0, _lodash6.default)(this.props, externalErrorsPath || 'errors', {});
        var baseErrors = this.omitDeep(externalErrors, touchedValues);

        if (validateAllValues) {
          return (0, _lodash18.default)({}, errors, baseErrors);
        } else {
          return (0, _lodash18.default)(pickErrors(errors, validatedValues), baseErrors);
        }
      }
    }, {
      key: '_valuesWithDefaults',
      value: function _valuesWithDefaults(_ref2) {
        var values = _ref2.values,
            touchedValues = _ref2.touchedValues;


        if (only) {
          var validateableFields = (0, _arrayFrom2.default)(only);

          var propValues = (0, _pickDeep2.default)(this.props, validateableFields);

          var defaultValues = (0, _pickDeep2.default)(ValidatedComponent.defaultProps, validateableFields);

          var propsWithDefaults = (0, _lodash18.default)({}, propValues, defaultValues);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: propsWithDefaults,
            overrides: wrapObject(values),
            deepMergeExemptions: wrapObject(touchedValues)
          });
        } else {
          var _propsWithDefaults = (0, _lodash18.default)({}, this.props, ValidatedComponent.defaultProps);

          return (0, _valuesWithDefaultsAndExemptions2.default)({
            defaultValue: _propsWithDefaults,
            overrides: wrapObject(values),
            deepMergeExemptions: wrapObject(touchedValues)
          });
        }
      }
    }, {
      key: 'clearValidationState',
      value: function clearValidationState(paths) {
        console.warn('Deprecation Warning: clearValidationState is deprecated. Please use clearValidationAndResetValues() instead.');

        this.clearValidationAndResetValues(paths);
      }
    }, {
      key: 'clearValidationAndResetValues',
      value: function clearValidationAndResetValues(paths) {
        var _this3 = this;

        if (paths) {
          (function () {
            var _state3 = _this3.state,
                touchedValues = _state3.touchedValues,
                validatedValues = _state3.validatedValues,
                values = _state3.values;


            var pathList = (0, _arrayFrom2.default)(paths);
            var newTouchedValues = (0, _lodash20.default)(touchedValues);
            var newValidatedValues = (0, _lodash20.default)(validatedValues);
            var newValues = (0, _lodash20.default)(values);

            (0, _lodash22.default)(pathList, function (path) {
              (0, _lodash4.default)(newTouchedValues, path);
              (0, _lodash4.default)(newValidatedValues, path);
              (0, _lodash4.default)(newValues, path);
            });

            _this3.setState({
              touchedValues: newTouchedValues,
              validatedValues: newValidatedValues,
              values: newValues
            });
          })();
        } else {
          this.setState(_extends({}, DEFAULT_STATE));
        }
      }
    }, {
      key: 'clearValidation',
      value: function clearValidation(paths) {
        var _this4 = this;

        if (paths) {
          (function () {
            var validatedValues = _this4.state.validatedValues;

            var newValidatedValues = (0, _lodash20.default)(validatedValues);

            var pathList = (0, _arrayFrom2.default)(paths);

            (0, _lodash22.default)(pathList, function (path) {
              (0, _lodash4.default)(newValidatedValues, path);
            });

            _this4.setState({
              validatedValues: newValidatedValues,
              validateAllValues: false
            });
          })();
        } else {

          this.setState({
            validatedValues: (0, _lodash20.default)(DEFAULT_STATE.validatedValues),
            validateAllValues: false
          });
        }
      }
    }, {
      key: 'clearTouchedValues',
      value: function clearTouchedValues() {
        this.setState({
          touchedValues: {},
          validateAllValues: false
        });
      }
    }, {
      key: 'changeHandler',
      value: function changeHandler(valuePath) {
        var _this5 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return function (event, value) {
          var valueToUse = (0, _lodash10.default)(options, 'value') ? options.value : value;
          _this5.changeValue(valuePath, valueToUse, options);
        };
      }
    }, {
      key: 'changeValue',
      value: function changeValue(valuePath, value) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        (0, _invariant2.default)(!Array.isArray(valuePath), 'Value path passed to changeValue was an array. If you want to change multiple values at once, use `changeValues` (pluralized) instead.');

        this.changeValues([[valuePath, value]], options);
      }
    }, {
      key: 'changesHandler',
      value: function changesHandler(changes, options) {
        var _this6 = this;

        return function () {
          _this6.changeValues(changes, options);
        };
      }
    }, {
      key: 'changeValues',
      value: function changeValues(changes) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        (0, _invariant2.default)(Array.isArray(changes), 'Changes must be an array of path-value pairs');

        if (options.validate) {

          var validatePaths = function () {
            if (options.validate === true) {
              return (0, _lodash24.default)(changes, function (_ref3) {
                var _ref4 = _slicedToArray(_ref3, 1),
                    valuePath = _ref4[0];

                return valuePath;
              });
            } else {
              return options.validate;
            }
          }();

          var nextState = this._newState({ validatePaths: validatePaths, changes: changes });

          this._validate(nextState, options.callback || _emptyFunc2.default);
        } else {
          var _nextState = this._newState({ changes: changes });

          this.setState(_nextState);
        }
      }
    }, {
      key: '_newState',
      value: function _newState(_ref5) {
        var validatePaths = _ref5.validatePaths,
            changes = _ref5.changes;
        var _state4 = this.state,
            validatedValues = _state4.validatedValues,
            touchedValues = _state4.touchedValues,
            values = _state4.values;


        var newValues = (0, _lodash20.default)(values);
        var newTouchedValues = (0, _lodash20.default)(touchedValues);
        var changingValues = [];

        if (changes) {
          (0, _lodash22.default)(changes, function (_ref6) {
            var _ref7 = _slicedToArray(_ref6, 2),
                path = _ref7[0],
                value = _ref7[1];

            (0, _lodash2.default)(newValues, path, value);
            (0, _lodash2.default)(newTouchedValues, path, path);
            changingValues.push(path);
          });
        }

        var newValidatedValues = function () {
          if (validatePaths) {
            var valuePathsList = (0, _arrayFrom2.default)(validatePaths);

            return (0, _mergeValidatedValuePaths2.default)(valuePathsList, validatedValues);
          } else {
            return validatedValues;
          }
        }();

        return _extends({}, this.state, {
          values: newValues,
          touchedValues: newTouchedValues,
          validatedValues: newValidatedValues,
          changingValues: changingValues
        });
      }
    }, {
      key: 'validateAllHandler',
      value: function validateAllHandler() {
        var _this7 = this;

        var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _emptyFunc2.default;


        return function () {
          _this7.validateAll(callback);
        };
      }
    }, {
      key: 'validateAll',
      value: function validateAll(callback) {
        this._validate(_extends({}, this.state, { validateAllValues: true }), callback);
      }
    }, {
      key: 'validateHandler',
      value: function validateHandler(validatePaths) {
        var _this8 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _emptyFunc2.default)();


        return function () {
          _this8.validate(validatePaths, callback);
        };
      }
    }, {
      key: 'validate',
      value: function validate(validatePaths) {
        var afterValidationCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;

        this._validate(this._newState({ validatePaths: validatePaths }), afterValidationCallback);
      }
    }, {
      key: '_validate',
      value: function _validate(nextState, afterValidationCallback) {
        var _this9 = this;

        var afterValidationHandler = this._afterValidationHandler(nextState, afterValidationCallback);

        var valuesWithDefaults = unwrapObject(this._valuesWithDefaults(nextState));

        var validatorOptions = _extends({}, nextState, {
          valuesWithDefaults: valuesWithDefaults,
          touchedValues: (0, _pickOutermost2.default)(nextState.touchedValues),
          validatedValues: (0, _pickOutermost2.default)(nextState.validatedValues),
          props: _extends({}, this.props)
        });

        if (joiSchema) {
          Joi.validate(valuesWithDefaults, joiSchema, _extends({ abortEarly: false }, joiOptions), function (joiError) {
            var joiErrorList = joiError && joiError.details || [];

            var errors = (0, _lodash16.default)(joiErrorList, function (joiErrors, _ref8) {
              var message = _ref8.message,
                  path = _ref8.path;

              var messageWithFieldNameRemoved = message.replace(/^\".+\" /, '');

              (0, _lodash2.default)(joiErrors, path, messageWithFieldNameRemoved);

              return joiErrors;
            }, {});

            _this9._callValidatorIfDefined((0, _arrayFrom2.default)(validator), _extends({}, validatorOptions, { errors: errors
            }), afterValidationHandler);
          });
        } else {
          this._callValidatorIfDefined((0, _arrayFrom2.default)(validator), _extends({}, validatorOptions, { errors: {}
          }), afterValidationHandler);
        }
      }
    }, {
      key: '_callValidatorIfDefined',
      value: function _callValidatorIfDefined(validatorList, validatorOptions, afterValidatorHasRun) {
        var _this10 = this;

        if (validatorList.length > 0) {
          var callback = function () {
            if (validatorList.length > 1) {

              return function (_ref9) {
                var values = _ref9.values,
                    errors = _ref9.errors;


                _this10._callValidatorIfDefined((0, _lodash8.default)(validatorList), _extends({}, validatorOptions, { values: values, errors: errors
                }), afterValidatorHasRun);
              };
            } else {
              return afterValidatorHasRun;
            }
          }();

          validatorList[0](validatorOptions, callback);
        } else {
          var values = validatorOptions.values,
              errors = validatorOptions.errors;


          afterValidatorHasRun({ values: values, errors: errors });
        }
      }
    }, {
      key: '_afterValidationHandler',
      value: function _afterValidationHandler(nextState, afterValidationComplete) {
        var _this11 = this;

        return function (_ref10) {
          var errors = _ref10.errors,
              values = _ref10.values;


          var newState = _extends({}, nextState, { errors: errors, values: values
          });

          _this11.setState(newState, afterValidationComplete);
        };
      }
    }]);

    return ValidatorComponent;
  }(_react.Component);

  ValidatorComponent.propTypes = {
    onSubmit: _propTypes2.default.func,
    errors: _propTypes2.default.object,
    onChange: _propTypes2.default.func
  };

  return ValidatorComponent;
};

ReactJoiValidation.setJoi = function (joiClass) {
  Joi = joiClass;
};

exports.default = ReactJoiValidation;