'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash.topath');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.set');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.isstring');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.reduce');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.clonedeep');

var _lodash12 = _interopRequireDefault(_lodash11);

var _isNumberString = require('./isNumberString');

var _isNumberString2 = _interopRequireDefault(_isNumberString);

var _Wildcard = require('../constants/Wildcard');

var _Wildcard2 = _interopRequireDefault(_Wildcard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function extendAnyTouchedAncestors(target, path) {
  var pathSegments = (0, _lodash2.default)(path);

  var ancestorPathSegments = touchedAncestorPathSegments(target, pathSegments);

  if (ancestorPathSegments) {

    var newPathNode = function () {
      var nextPathSegment = pathSegments[ancestorPathSegments.length];

      if ((0, _isNumberString2.default)(nextPathSegment)) {
        return [];
      } else {
        return {};
      }
    }();

    newPathNode[_Wildcard2.default] = _Wildcard2.default;

    (0, _lodash6.default)(target, ancestorPathSegments, newPathNode);
  }
}

function touchedAncestorPathSegments(target, pathSegments) {

  var index = 0;

  while (index <= pathSegments.length) {
    var thisPathSegments = pathSegments.slice(0, index + 1);

    var thisValue = (0, _lodash4.default)(target, thisPathSegments);

    if ((0, _lodash8.default)(thisValue)) {
      return thisPathSegments;
    }

    index++;
  }
}

function mergeValidatedValuePaths(newTouchedValuePaths, previouslyTouchedValues) {

  return (0, _lodash10.default)(newTouchedValuePaths, function (updatedTouchedValues, path) {

    if (path !== _Wildcard2.default) {

      extendAnyTouchedAncestors(updatedTouchedValues, path);

      (0, _lodash6.default)(updatedTouchedValues, path, path);
    }

    return updatedTouchedValues;
  }, (0, _lodash12.default)(previouslyTouchedValues));
}

exports.default = mergeValidatedValuePaths;