'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash.isundefined');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.isplainobject');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.isstring');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.uniq');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.keys');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.reduce');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.map');

var _lodash14 = _interopRequireDefault(_lodash13);

var _Wildcard = require('../constants/Wildcard');

var _Wildcard2 = _interopRequireDefault(_Wildcard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function valueAlreadyTouched(value) {
  return (0, _lodash6.default)(value) || value && value[_Wildcard2.default];
}

function valuesWithDefaultsAndExemptions(_ref) {
  var _ref$deepMergeExempti = _ref.deepMergeExemptions,
      deepMergeExemptions = _ref$deepMergeExempti === undefined ? {} : _ref$deepMergeExempti,
      overrides = _ref.overrides,
      defaultValue = _ref.defaultValue;


  if (valueAlreadyTouched(deepMergeExemptions) || (0, _lodash2.default)(defaultValue)) {

    return overrides;
  } else {

    if ((0, _lodash2.default)(overrides)) {

      return defaultValue;
    } else {

      if ((0, _lodash4.default)(overrides)) {

        var unionOfObjectKeys = (0, _lodash8.default)([].concat(_toConsumableArray((0, _lodash10.default)(defaultValue)), _toConsumableArray((0, _lodash10.default)(overrides))));

        return (0, _lodash12.default)(unionOfObjectKeys, function (memo, key) {

          if (valueAlreadyTouched(deepMergeExemptions[key])) {

            memo[key] = overrides[key];
          } else {

            memo[key] = valuesWithDefaultsAndExemptions({
              defaultValue: defaultValue[key],
              overrides: overrides[key],
              deepMergeExemptions: deepMergeExemptions[key]
            });
          }

          return memo;
        }, {});
      } else if (Array.isArray(overrides)) {

        var overridesIsLongerThanDefault = overrides.length > defaultValue.length;

        if (overridesIsLongerThanDefault) {

          return (0, _lodash14.default)(overrides, function (overrideElement, index) {

            if (valueAlreadyTouched(deepMergeExemptions[index])) {

              return overrideElement;
            } else {

              return valuesWithDefaultsAndExemptions({
                defaultValue: defaultValue[index],
                overrides: overrideElement,
                deepMergeExemptions: deepMergeExemptions[index]
              });
            }
          });
        } else {

          return (0, _lodash14.default)(defaultValue, function (defaultValueElement, index) {

            if (valueAlreadyTouched(deepMergeExemptions[index])) {

              return overrides[index];
            } else {

              return valuesWithDefaultsAndExemptions({
                defaultValue: defaultValueElement,
                overrides: overrides[index],
                deepMergeExemptions: deepMergeExemptions[index]
              });
            }
          });
        }
      } else {

        return overrides;
      }
    }
  }
}

exports.default = valuesWithDefaultsAndExemptions;